import 'iroute_nested.dart';
import 'page_list.dart';
import 'package:flutter/material.dart';
import 'iroute_common.dart';

class IRouteAppShell extends StatefulWidget {
  IRouteAppShell({required this.pageList, required this.routes});
  final PageList pageList;
  final Map<String, RouteBuilder> routes;

  @override
  IRouteAppShellState createState() =>
      IRouteAppShellState(pageList: pageList, routes: routes);
}

class IRouteAppShellState extends State {
  IRouteAppShellState({required this.pageList, required this.routes})
      : _routerDelegate = IRouteNested(pageList: pageList, routes: routes);

  final PageList pageList;
  final Map<String, RouteBuilder> routes;
  final IRouteNested _routerDelegate;
  ChildBackButtonDispatcher? _backButtonDispatcher;

  @override
  void initState() {
    //必须，否则后退功能不会刷新底部导航按钮位置
    //_routerDelegate.stack.root.addListener(() => setState(() {}));
    super.initState();
  }

  @override
  void dispose() {
    //_routerDelegate.stack.root.removeListener(() => setState(() {}));
    super.dispose();
  }

  @override
  void didUpdateWidget(covariant IRouteAppShell oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    _backButtonDispatcher = Router.of(context)
        .backButtonDispatcher!
        .createChildBackButtonDispatcher();
  }

  @override
  Widget build(BuildContext context) {
    _backButtonDispatcher!.takePriority();

    //当前url不同？
    //所以pageList的操作应在appShell而非nested代理。

    if (pageList.url != _routerDelegate.stack.currentConfiguration) {
      //print('两者不匹配！！！修改');
      pageList.changeToUrl(_routerDelegate.stack.currentConfiguration);
    }
    // else
    //   print('pagelist和root的url是一致的！');

    //应该先创建items吧
    List<BottomNavigationBarItem> items = [];
    pageList.pages.forEach((element) {
      items.add(element.bottom);
    });

    return Scaffold(
      body: Router(
        routerDelegate: _routerDelegate,
        backButtonDispatcher: _backButtonDispatcher,
      ),
      bottomNavigationBar: BottomNavigationBar(
        type: BottomNavigationBarType.fixed,
        items: items,
        currentIndex: _routerDelegate.selectedPage,
        onTap: (newIndex) {
          //print('点击按钮: ${newIndex == 1 ? "设置" : "主页"}');
          //print('newIndex=$newIndex');
          _routerDelegate.selectedPage = newIndex;
          //setState(() {});
          //_routerDelegate.notifyListeners();
        },
      ),
    );
  }
}
